#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "../src/tcpip.c"

int main(void) {
  uint8_t hdr[] = {0x45, 0, 0,    0x54, 0x4, 0x4b, 0,    0,    0x40, 1,
                   0,    0, 0xc0, 0xa8, 0,   0x3b, 0xc0, 0xa8, 0,    7};
  assert(ipcsum(hdr, hdr + sizeof(hdr)) == 0xcbf4);
  // printf("%hx\n", ipcsum(hdr, hdr + sizeof(hdr)));  // f4cb

  // 0000	7e ff 7d 23 c0 21 7d 21 7d 21 7d 20 7d 32 7d 22
  // 0010	7d 26 7d 20 7d 2a 7d 20 7d 20 7d 23 7d 24 c0 23
  // 0020	7d 27 7d 22 7d 28 7d 22 55 83 7e
  uint8_t hdlc[] = {0x7e, 0xff, 0x7d, 0x23, 0xc0, 0x21, 0x7d, 0x21, 0x7d,
                    0x21, 0x7d, 0x20, 0x7d, 0x32, 0x7d, 0x22, 0x7d, 0x26,
                    0x7d, 0x20, 0x7d, 0x2a, 0x7d, 0x20, 0x7d, 0x20, 0x7d,
                    0x23, 0x7d, 0x24, 0xc0, 0x23, 0x7d, 0x27, 0x7d, 0x22,
                    0x7d, 0x28, 0x7d, 0x22, 0x55, 0x83, 0x7e};
  size_t n = ppp_decode(hdlc + 1, sizeof(hdlc) - 4, hdlc);
  assert(mkfcs(hdlc, n) == 0x8355);

  return 0;
}
